"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var src_exports = {};
__export(src_exports, {
  default: () => src_default,
  workerPlugin: () => workerPlugin
});
module.exports = __toCommonJS(src_exports);
var import_path = __toESM(require("path"));
var import_utils = require("@modern-js/utils");
var import_constants = require("./constants");
var import_code = require("./code");
const workerPlugin = () => ({
  name: "@modern-js/plugin-worker",
  setup: (ctx) => {
    return {
      async config() {
        return {
          output: {
            disableNodePolyfill: false
          }
        };
      },
      async afterDev() {
        var _configContext_deploy_worker;
        const { appDirectory, distDirectory } = ctx.useAppContext();
        const configContext = ctx.useResolvedConfigContext();
        if (!(0, import_utils.isServiceWorker)(configContext)) {
          return;
        }
        const enableWorkerInWeb = configContext.deploy.enableWorker || ((_configContext_deploy_worker = configContext.deploy.worker) === null || _configContext_deploy_worker === void 0 ? void 0 : _configContext_deploy_worker.web);
        writeWorkerServerFile(appDirectory, distDirectory, enableWorkerInWeb);
      },
      async afterBuild() {
        var _configContext_deploy_worker;
        const { appDirectory, distDirectory } = ctx.useAppContext();
        const configContext = ctx.useResolvedConfigContext();
        if (!(0, import_utils.isServiceWorker)(configContext)) {
          return;
        }
        const enableWorkerInWeb = configContext.deploy.enableWorker || ((_configContext_deploy_worker = configContext.deploy.worker) === null || _configContext_deploy_worker === void 0 ? void 0 : _configContext_deploy_worker.web);
        writeWorkerServerFile(appDirectory, distDirectory, enableWorkerInWeb);
      }
    };
  }
});
const writeWorkerServerFile = (appDirectory, distDirectory, enableWorkerInWeb) => {
  const workServerDir = import_path.default.join(distDirectory, import_constants.WORKER_SERVER);
  const serverHookDir = import_path.default.join(appDirectory, import_utils.SERVER_DIR, import_constants.WEB_APP_NAME);
  const isExistsServerHook = import_utils.fs.existsSync(`${serverHookDir}.ts`) || import_utils.fs.existsSync(`${serverHookDir}.js`);
  const relativePath = import_path.default.relative(workServerDir, serverHookDir);
  import_utils.fs.removeSync(workServerDir);
  import_utils.fs.mkdirSync(workServerDir);
  import_utils.fs.writeFileSync(import_path.default.join(workServerDir, import_constants.WORKER_SERVER_ENTRY), (0, import_code.worker)());
  const routeJSON = import_path.default.join(distDirectory, import_utils.ROUTE_SPEC_FILE);
  const { routes } = import_utils.fs.readJSONSync(routeJSON);
  let importStr = ``;
  let pageStr = ``;
  const routeArr = [];
  if (isExistsServerHook && !enableWorkerInWeb) {
    importStr += `import * as ${import_constants.SERVER_HOOKS} from '${relativePath}'
`;
  }
  routes.forEach((route) => {
    if (route.isSSR) {
      importStr += `import { serverRender as ${route.entryName}ServerRender } from "../${route.worker}";
`;
    }
    if (!route.isApi) {
      importStr += `import ${route.entryName}template from "../${route.entryPath}";
`;
      pageStr += `"${route.urlPath}": {
        ${isExistsServerHook && !enableWorkerInWeb ? `${import_constants.SERVER_HOOKS},` : ""}
        entryName: "${route.entryName}",
        template: ${route.entryName}template,
        serverRender: ${route.isSSR ? `${route.entryName}ServerRender` : void 0},
      },`;
      routeArr.push({
        entryName: route.entryName,
        isSSR: route.isSSR,
        urlPath: route.urlPath
      });
    }
  });
  const manifest = `
${importStr}

export const manifest = {
  pages: {
    ${pageStr}
  },
  routes: ${JSON.stringify(routeArr, null, "   ")}
}
        `;
  import_utils.fs.writeFileSync(import_path.default.join(workServerDir, import_constants.MANIFEST_FILE), manifest);
  const pkg = import_utils.fs.readJSONSync(import_path.default.join(appDirectory, import_constants.PKG_FILE));
  import_utils.fs.writeFileSync(import_path.default.join(distDirectory, import_constants.WRANGLER_FILE), `name = "${pkg.name}"
main = "${import_path.default.join(import_constants.WORKER_SERVER, import_constants.WORKER_SERVER_ENTRY)}"
compatibility_date = "${(/* @__PURE__ */ new Date()).toISOString().substring(0, 10)}"
        `);
};
var src_default = workerPlugin;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  workerPlugin
});
